REM QBasic program that sends a file to a HP 21xx minicomputer
REM via a simple PTR emulator. Protocol is wait for "!" from the
REM serial port then send the next byte of the file to the port.
REM This must be run in pure dos or DosEmu/FreeDos under Linux
REM Not for running under Windows which prevents port access
REM Initial version 8/13/07 by WTN

comm$ = "COM1:"
PRINT "*** HPSEND ***"
PRINT "Enter COMx: to change port"

promptforname:
PRINT "File to send: ";
LINE INPUT filename$
IF filename$ = "" GOTO exitprogram
IF filename$ = "COM1:" THEN comm$ = "COM1:": GOTO promptforname
IF filename$ = "COM2:" THEN comm$ = "COM2:": GOTO promptforname
IF filename$ = "COM3:" THEN comm$ = "COM3:": GOTO promptforname
IF filename$ = "COM4:" THEN comm$ = "COM4:": GOTO promptforname
ON ERROR GOTO filenotfound
OPEN filename$ FOR INPUT AS #2: CLOSE #2
ON ERROR GOTO othererror
odd = 0  'reset getbyte sub
count = 0 'for progress display
OPEN filename$ FOR BINARY AS #2
REM the following code was adapted from "DIALS3.BAS" found at
REM http://home.alphalink.com.au/~derekw/ane/serport.htm
OPEN comm$ + "9600,N,8,1,CD0,CS0,DS0,OP0,TB2048,RB2048" FOR RANDOM AS #1
PRINT "Sending file, press Esc to stop"
waitforserial:
IF EOF(2) GOTO endoffile
exitloop = 0
WHILE (EOF(1) AND exitloop = 0)
IF INKEY$ = CHR$(27) THEN exitloop = 1
WEND
IF exitloop GOTO filedone
char$ = INPUT$(1, 1)
IF char$ <> "!" GOTO waitforserial
GOSUB getbyte
PRINT #1, CHR$(byte);
IF count MOD 1024 = 0 THEN PRINT "*";
count = count + 1
IF INKEY$ = CHR$(27) GOTO filedone
GOTO waitforserial

filedone:
PRINT
CLOSE
GOTO promptforname

endoffile:
PRINT: PRINT "End of file reached"
CLOSE
GOTO promptforname

filenotfound:
PRINT "File not found"
RESUME continueprogram

othererror:
PRINT "An error occured"
RESUME continueprogram

continueprogram:
CLOSE
GOTO promptforname

getbyte:
'return one byte in byte from file #2 (open in binary mode)
'has to get 2 bytes from file then split between calls
IF odd = 0 THEN
GET #2, , inword%  'get 2 bytes
iwv = inword%
IF iwv < 0 THEN iwv = iwv + 65536
byte = iwv - INT(iwv / 256) * 256 'return low byte
odd = 1
ELSE
byte = INT(iwv / 256) 'return high byte
odd = 0
END IF
RETURN

exitprogram:
SYSTEM

